from parserlib1 import *
from mainloop1 import mainLoop

def condition(f) :
    def proc() :
        x = next()
        if not f(x) :
            error("parser error")
        return x
    return proc

def zeroOrMore(parser) :
    def proc() :
        result = []
        while True :
            p = save()
            try :
                x = parser()
                result.append(x)
            except ParserError :
                restore(p)
                break
        return result
    return proc

def oneOrMore(parser) :
    rest = zeroOrMore(parser)
    def proc() :
        return [parser()] + rest()
    return proc

def isDigit(x) : return (x >= '0') and (x <= '9')

digit = condition(isDigit)
numeral = oneOrMore(digit)

mainLoop(numeral)
