from parserlib2 import *
from mainloop2 import mainLoop

def condition(f, modifier=lambda x : x) :
    def proc() :
        x = next()
        if not f(x) :
            error("parser error")
        return modifier(x)
    return proc

def zeroOrMore(parser) :
    def proc() :
        result = []
        while True :
            p = save()
            try :
                x = parser()
                result.append(x)
            except ParserError :
                restore(p)
                break
        return result
    return proc

def oneOrMore(parser, modifier=lambda x : x) :
    rest = zeroOrMore(parser)
    def proc() :
        return modifier([parser()] + rest())
    return proc

def isDigit(x) : return (x >= '0') and (x <= '9')
def digitToNum(x) : return ord(x) - ord('0')

def combineDigits(a) :
    return reduce(lambda n,d: n*10+d, a, 0)

digit = condition(isDigit, digitToNum)
numeral = oneOrMore(digit, combineDigits)

mainLoop(numeral)
